﻿#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include "radarserver.h"
#include "radarsiggen.h"
#include "simdisplay.h"
#include "interceptradar.h"
#include <iostream>
#include <QStandardItemModel>
#include <QtCharts>
QT_BEGIN_NAMESPACE
QT_CHARTS_USE_NAMESPACE
namespace Ui { class MainWindow; }
QT_END_NAMESPACE

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    QThread *radarServerThread;
    QThread *radarSigGenThread;
    RadarServer *radarServer;
    RadarSigGen *radarSigGen;

    MainWindow(QWidget *parent = nullptr);
    ~MainWindow();

private slots:
    void on_pushButton_42_clicked();

    void on_comboBox_radarType_currentIndexChanged(const QString &arg1);
    void on_pushButton_5_clicked();
    void on_CreateInterceptRadarButton_clicked();


private:
    Ui::MainWindow *ui;
    SimDisplay *simDisplay;
    interceptRadar *interceptRadarList[100];
    int interceptRadarNum = 0;
    QChartView * MyChartView;   // 画布对象
    QChart MyChart;             // 图表对象
    QLineSeries MyLineSeries;   // 展示在图表对象上面的线对象

    QValueAxis *xAxis ;
     QValueAxis *yAxis ;
    QStandardItemModel *tableview;
    double len;
    int rows;

};
#endif // MAINWINDOW_H
